// MatrixGame - SR2 Planetary battles engine
// Copyright (C) 2012, Elemental Games, Katauri Interactive, CHK-Games
// Licensed under GPLv2 or any later version
// Refer to the LICENSE file included

#ifndef STRING_CONSTANTS
#define STRING_CONSTANTS

#define FILE_CONFIGURATION          L"robots.dat"
#define FILE_CONFIGURATION_LOCATION L"cfg\\"

// billboards

// sorted
#define BB_TEXTURE_NAME_SMOKE      L"Smoke"
#define BB_TEXTURE_NAME_FIRE       L"Fire"
#define BB_TEXTURE_NAME_SELDOT     L"Seldot"
#define BB_TEXTURE_NAME_PATHDOT    L"Pathdot"
#define BB_TEXTURE_NAME_SCOREPLUS  L"ScorePlus"
#define BB_TEXTURE_NAME_SCORE0     L"Score0"
#define BB_TEXTURE_NAME_SCORE1     L"Score1"
#define BB_TEXTURE_NAME_SCORE2     L"Score2"
#define BB_TEXTURE_NAME_SCORE3     L"Score3"
#define BB_TEXTURE_NAME_SCORE4     L"Score4"
#define BB_TEXTURE_NAME_SCORE5     L"Score5"
#define BB_TEXTURE_NAME_SCORE6     L"Score6"
#define BB_TEXTURE_NAME_SCORE7     L"Score7"
#define BB_TEXTURE_NAME_SCORE8     L"Score8"
#define BB_TEXTURE_NAME_SCORE9     L"Score9"
#define BB_TEXTURE_NAME_SCOREICON1 L"ScoreIcon1"
#define BB_TEXTURE_NAME_SCOREICON2 L"ScoreIcon2"
#define BB_TEXTURE_NAME_SCOREICON3 L"ScoreIcon3"
#define BB_TEXTURE_NAME_SCOREICON4 L"ScoreIcon4"
#define BB_TEXTURE_NAME_SCOREICONS L"ScoreIcons"

// intense
#define BB_TEXTURE_NAME_FLAMEFRAME0 L"FlameFrame0"
#define BB_TEXTURE_NAME_FLAMEFRAME1 L"FlameFrame1"
#define BB_TEXTURE_NAME_FLAMEFRAME2 L"FlameFrame2"
#define BB_TEXTURE_NAME_FLAMEFRAME3 L"FlameFrame3"
#define BB_TEXTURE_NAME_FLAMEFRAME4 L"FlameFrame4"
#define BB_TEXTURE_NAME_FLAMEFRAME5 L"FlameFrame5"
#define BB_TEXTURE_NAME_FLAMEFRAME6 L"FlameFrame6"
#define BB_TEXTURE_NAME_FLAMEFRAME7 L"FlameFrame7"

#define BB_TEXTURE_NAME_REPGLOW    L"Repair_glow"
#define BB_TEXTURE_NAME_REPGLOWEND L"Repair_glow_end"

#define BB_TEXTURE_NAME_SMOKE_INTENSE L"Smoke_intense"
#define BB_TEXTURE_NAME_FIRE_INTENSE  L"Fire_intense"
#define BB_TEXTURE_NAME_POINTLIGHT    L"Pointlight"
#define BB_TEXTURE_NAME_LASEREND      L"Laserend"
#define BB_TEXTURE_NAME_GLOWBEAMEND   L"GlowBeamEnd"
#define BB_TEXTURE_NAME_FLAME         L"Flame"
#define BB_TEXTURE_NAME_PLASMA1       L"Plasma1"
#define BB_TEXTURE_NAME_PLASMA2       L"Plasma2"
#define BB_TEXTURE_NAME_INTENSE       L"Intense"

#define BB_TEXTURE_NAME_LASER       L"Laser"
#define BB_TEXTURE_NAME_GUNFIRE1    L"Gunfire1"
#define BB_TEXTURE_NAME_GUNFIRE2    L"Gunfire2"
#define BB_TEXTURE_NAME_GUNFIRE3    L"Gunfire3"
#define BB_TEXTURE_NAME_TRASSA      L"Trassa"
#define BB_TEXTURE_NAME_SHLEIF      L"Shleif"
#define BB_TEXTURE_NAME_FIRESTREAM1 L"Fire_stream1"
#define BB_TEXTURE_NAME_FIRESTREAM2 L"Fire_stream2"
#define BB_TEXTURE_NAME_FIRESTREAM3 L"Fire_stream3"
#define BB_TEXTURE_NAME_FIRESTREAM4 L"Fire_stream4"
#define BB_TEXTURE_NAME_FIRESTREAM5 L"Fire_stream5"
#define BB_TEXTURE_NAME_GLOWBEAM    L"GlowBeam"
#define BB_TEXTURE_NAME_FLAMELINE   L"Flame_line"
#define BB_TEXTURE_NAME_SPARK       L"Spark"
#define BB_TEXTURE_NAME_EFIELD      L"Efield"

//#define TEXTURE_PATH_FIRE                       L"Matrix\\Textures\\Billboard\\fire1"
//#define TEXTURE_PATH_POINTLIGHT                 L"Matrix\\Textures\\pointlight_inv"
//#define TEXTURE_PATH_SELDOT                     L"Matrix\\Textures\\Billboard\\selpoint"
//#define TEXTURE_PATH_PATHDOT                    L"Matrix\\Textures\\Billboard\\pathpoint"
//#define TEXTURE_PATH_GLOWBEAMEND                L"Matrix\\Textures\\Billboard\\GlowBeamEnd0"
//#define TEXTURE_PATH_FLAME0                     L"Matrix\\Textures\\Billboard\\flame0"
//#define TEXTURE_PATH_PLASMA2                    L"Matrix\\Textures\\Billboard\\plasma2"
//#define TEXTURE_PATH_EXPLOSION_INTENSE          L"Matrix\\Textures\\Billboard\\Smoke2"

//#define TEXTURE_PATH_LASER                      L"Matrix\\Textures\\Billboard\\Laser"
//#define TEXTURE_PATH_GUN_FIRE1                  L"Matrix\\Textures\\Billboard\\gun_fire01"
//#define TEXTURE_PATH_GUN_FIRE2                  L"Matrix\\Textures\\Billboard\\gun_fire02"
//#define TEXTURE_PATH_GUN_FIRE3                  L"Matrix\\Textures\\Billboard\\gun_fire03"
//#define TEXTURE_PATH_TRASSA                     L"Matrix\\Textures\\Billboard\\minomet"
//#define TEXTURE_PATH_SHLEIF                     L"Matrix\\Textures\\Billboard\\minomet"
//#define TEXTURE_PATH_FIRESTREAM1                  L"Matrix\\Textures\\Billboard\\firestream0"
//#define TEXTURE_PATH_FIRESTREAM2                  L"Matrix\\Textures\\Billboard\\firestream1"
//#define TEXTURE_PATH_FIRESTREAM3                  L"Matrix\\Textures\\Billboard\\firestream2"
//#define TEXTURE_PATH_FIRESTREAM4                  L"Matrix\\Textures\\Billboard\\firestream3"
//#define TEXTURE_PATH_FIRESTREAM5                  L"Matrix\\Textures\\Billboard\\firestream4"
//#define TEXTURE_PATH_GLOWBEAM                   L"Matrix\\Textures\\Billboard\\GlowBeam0"
//#define TEXTURE_PATH_FLAMELINE                  L"Matrix\\Textures\\Billboard\\flameline"
//#define TEXTURE_PATH_PLASMA1                    L"Matrix\\Textures\\Billboard\\plasma1"
//#define TEXTURE_PATH_EXPLOSION_SPARK            L"Matrix\\Textures\\Billboard\\Spark"
//#define TEXTURE_PATH_ELEVATORFIELD              L"Matrix\\Textures\\Billboard\\efield"

// textures

#define TEXTURE_PATH_POINTLIGHT L"Matrix\\Textures\\pointlight"

#define TEXTURE_PATH_PB      L"Matrix\\Textures\\pb"
#define TEXTURE_PATH_SELBACK L"Matrix\\Textures\\selback"

#define TEXTURE_PATH_SPOT           L"Matrix\\Textures\\LandSpots\\spot"
#define TEXTURE_PATH_HIT            L"Matrix\\Textures\\LandSpots\\spot_hit"
#define TEXTURE_PATH_SELECTION      L"Matrix\\Textures\\LandSpots\\spot_move_to"
#define TEXTURE_PATH_VORONKA        L"Matrix\\Textures\\LandSpots\\varonka"
#define TEXTURE_PATH_TURRET_RADIUS  L"Matrix\\Textures\\LandSpots\\spot_turr2"
#define TEXTURE_PATH_SOLE_TRACK     L"Matrix\\Textures\\LandSpots\\sole"
#define TEXTURE_PATH_SOLE_WHEEL     L"Matrix\\Textures\\LandSpots\\sole_w"
#define TEXTURE_PATH_SOLE_PNEUMATIC L"Matrix\\Textures\\LandSpots\\sole_p"

//#define TEXTURE_PATH_INSHOREWAVE                L"Matrix\\Textures\\Water\\inshorewave"
//#define TEXTURE_PATH_WATER                      L"Matrix\\Textures\\Water\\1"
//#define TEXTURE_PATH_WATERREFLECTION            L"Matrix\\Textures\\Water\\Mirror"

#define TEXTURE_PATH_REFLECTION L"Matrix\\Textures\\reflection"

#define TEXTURE_PATH_DUST L"Matrix\\Textures\\Billboard\\Dust"

#define TEXTURE_PATH_BIGBOOM L"Matrix\\Textures\\Effects\\bigboom"

#define TEXTURE_PATH_GUN_FIRE     L"Matrix\\Textures\\Effects\\gun_fire"
#define TEXTURE_PATH_GUN_BULLETS1 L"Matrix\\Textures\\Effects\\bullet1"
#define TEXTURE_PATH_GUN_BULLETS2 L"Matrix\\Textures\\Effects\\bullet2"
#define TEXTURE_PATH_SPLASH       L"Matrix\\Textures\\Effects\\splash"

#define TEXTURE_PATH_KEELWATER L"Matrix\\Textures\\Billboard\\keelwater"
#define TEXTURE_PATH_WAVE      L"Matrix\\Textures\\Billboard\\kryg00"
#define TEXTURE_PATH_ZAHVAT    L"Matrix\\Textures\\Billboard\\zahspot"
#define TEXTURE_PATH_OBJSEL    L"Matrix\\Textures\\Billboard\\selection"

#define TEXTURE_PATH_MOVETO L"Matrix\\Textures\\Billboard\\moveto"

//#define TEXTURE_FLYER_BODY                      L"Matrix\\Helicopter\\main.png"
//#define TEXTURE_FLYER_ENGINE                    L"Matrix\\Helicopter\\main.png"
//#define TEXTURE_FLYER_VINT                      L"Matrix\\Helicopter\\main.png"
//#define TEXTURE_FLYER_VINT_1                    L"Matrix\\Helicopter\\screw1.png"
//#define TEXTURE_FLYER_WEAPON_1                  L"Matrix\\Helicopter\\helicopter_w.png"

//#define TEXTURE_BUILDING_PLATFORM1              L"Matrix\\Building\\b1_platform.png"
//#define TEXTURE_BUILDING_PLATFORM2              L"Matrix\\Building\\b2_platform.png"
//#define TEXTURE_BUILDING_PLATFORM3              L"Matrix\\Building\\b3_platform.png"
//#define TEXTURE_BUILDING_PLATFORM4              L"Matrix\\Building\\b4_platform.png"
// objects

//#define OBJECT_PATH_FLYER_BODY                  L"Matrix\\Helicopter\\main.vo"
//#define OBJECT_PATH_FLYER_ENGINE                L"Matrix\\Helicopter\\engine.vo"
//#define OBJECT_PATH_FLYER_VINT                  L"Matrix\\Helicopter\\screw.vo"
//#define OBJECT_PATH_FLYER_WEAPON_1              L"Matrix\\Helicopter\\weapon1.VO"
//#define OBJECT_PATH_FLYER_WEAPON_2              L"Matrix\\Helicopter\\weapon2.VO"
//#define OBJECT_PATH_FLYER_WEAPON_3              L"Matrix\\Helicopter\\weapon3.VO"

#define OBJECT_PATH_BUILDINGS_RUINS L"Matrix\\Building\\ruins\\"

#define OBJECT_PATH_BASE_00 L"Matrix\\Building\\b0.cvo"
#define OBJECT_PATH_BASE_01 L"Matrix\\Building\\b1.cvo"
#define OBJECT_PATH_BASE_02 L"Matrix\\Building\\b2.cvo"
#define OBJECT_PATH_BASE_03 L"Matrix\\Building\\b3.cvo"
#define OBJECT_PATH_BASE_04 L"Matrix\\Building\\b4.cvo"
#define OBJECT_PATH_BASE_05 L"Matrix\\Building\\b5.cvo"

#define OBJECT_PATH_ROCKET L"Matrix\\Bullets\\roket.VO"
#define OBJECT_PATH_MINA   L"Matrix\\Bullets\\mina.VO"
#define OBJECT_PATH_GUN    L"Matrix\\Bullets\\bullet.VO"

#define OBJECT_PATH_ROBOT_HEAD    L"Matrix\\Robot\\Head"
#define OBJECT_PATH_ROBOT_CHASSIS L"Matrix\\Robot\\Chassis"
#define OBJECT_PATH_ROBOT_WEAPON  L"Matrix\\Robot\\Weapon"
#define OBJECT_PATH_ROBOT_ARMOR   L"Matrix\\Robot\\Armor"

#define OBJECT_PATH_LOGO_RED   L"Matrix\\Logos\\RobotLogosR.VO"
#define OBJECT_PATH_LOGO_GREEN L"Matrix\\Logos\\RobotLogosG.VO"
#define OBJECT_PATH_LOGO_BLUE  L"Matrix\\Logos\\RobotLogosB.VO"

#define OBJECT_PATH_MOVETO L"Matrix\\MoveTo\\moveto.VO"

#define OBJECT_PATH_CANNONS L"Matrix\\Cannon\\"

// matrices
#define MATRIX_BASE_PLACE L"Place"

// animations
#define ANIMATION_NAME_BEGIN_MOVE_BACK L"BeginMoveBack"
#define ANIMATION_NAME_END_MOVE_BACK   L"EndMoveBack"
#define ANIMATION_NAME_MOVE_BACK       L"MoveBack"

#define ANIMATION_NAME_BEGIN_MOVE L"BeginMove"
#define ANIMATION_NAME_END_MOVE   L"EndMove"
#define ANIMATION_NAME_MOVE       L"Move"
#define ANIMATION_NAME_STAY       L"Stay"
#define ANIMATION_NAME_ROTATE     L"Rotate"

#define ANIMATION_NAME_IDLE     L"Idle"
#define ANIMATION_NAME_FIRE     L"Fire"
#define ANIMATION_NAME_FIRELOOP L"FireLoop"

#define TEMPLATE_PAUSE               L"Pause"
#define TEMPLATE_DIALOG_BEGIN        L"Begin"
#define TEMPLATE_DIALOG_EXIT         L"Exit"
#define TEMPLATE_DIALOG_LOOSE        L"Loose"
#define TEMPLATE_DIALOG_WIN          L"Win"
#define TEMPLATE_DIALOG_MENU         L"Menu"
#define TEMPLATE_DIALOG_RESET        L"Reset"
#define TEMPLATE_DIALOG_SURRENDER    L"Surrender"
#define TEMPLATE_DIALOG_STATISTICS   L"Stat"
#define TEMPLATE_DIALOG_STATISTICS_D L"StatD"

// params
//#define BURN_PARAM_VO                           L"BurnableVO"
//#define BURN_PARAM_TEX                          L"BurnableTex"
//#define BREAK_PARAM_VO                          L"BreakableVO"
#define BREAK_PARAM_HITPOINT L"Hitpoint"

#define CFG_TOPSIZE         L"TextureTopMinSize"
#define CFG_TOPSCALE        L"TextureTopDownScaleFactor"
#define CFG_BOTSIZE         L"TextureBottomMinSize"
#define CFG_BOTSCALE        L"TextureBottomDownScaleFactor"
#define CFG_LANDTEXTURES16  L"LandTextures16Bit"
#define CFG_SOFTWARECURSOR  L"SoftwareCursor"
#define CFG_GLOSSLAND       L"LandTexturesUseGloss"
#define CFG_GLOSSOBJECT     L"ObjectTexturesUseGloss"
#define CFG_OBJECTTEX16     L"ObjectTextures16Bit"
#define CFG_DEBUGINFO       L"DebugInfo"
#define CFG_VERTEXLIGHT     L"VertexLight"
#define CFG_ASSIGNKEY       L"AssignKey"
#define CFG_IZVRATMS        L"IzvratMultiSelection"
#define CFG_ROBOTSHADOW     L"RobotShadow"
#define CFG_SKYBOX          L"SkyBox"
#define CFG_OBJECTTOMINIMAP L"ObjectsToMinimap"
#define CFG_GAMMARAMP       L"GammaRamp"
#define CFG_MAXFPS          L"MaxFps"

#define PAR_TEMPLATES               L"Templates"
#define PAR_REPLACE                 L"Replaces"
#define PAR_REPLACE_DIFFICULTY      L"_difficulty"
#define PAR_REPLACE_BEGIN_ICON_RACE L"_race"
#define PAR_REPLACE_BEGIN_TEXT      L"_begin"
#define PAR_REPLACE_END_TEXT_LOOSE  L"_loose"
#define PAR_REPLACE_END_TEXT_WIN    L"_win"
#define PAR_REPLACE_END_TEXT_PLANET L"_planet"

//#define PAR_SOURCE_TEXTURES                     L"Ter"
//#define PAR_SOURCE_BORDERS                      L"TerBorder"
#define PAR_SOURCE_IMAGES              L"Images"
#define PAR_SOURCE_DIFFICULTY          L"Difficulty"
#define PAR_SOURCE_BILLBOARDS          L"Billboards"
#define PAR_SOURCE_BILLBOARDS_TEXTURES L"Textures"
#define PAR_SOURCE_BILLBOARDS_TEXSORT  L"TexSort"
//#define PAR_SOURCE_BILLBOARDS_TEXINTENSE        L"TexIntense"
#define PAR_SOURCE_CURSORS                       L"Cursors"
#define PAR_SOURCE_DAMAGES                       L"Damages"
#define PAR_SOURCE_DAMAGES_OBJECT                L"Object"
#define PAR_SOURCE_DAMAGES_CANNON                L"Cannon"
#define PAR_SOURCE_DAMAGES_BUILDING              L"Building"
#define PAR_SOURCE_DAMAGES_ROBOT                 L"Robot"
#define PAR_SOURCE_DAMAGES_FLYER                 L"Flyer"
#define PAR_SOURCE_DAMAGES_HITPOINT              L"HITPOINT"
#define PAR_SOURCE_DAMAGES_WEAPON_PLASMA         L"WEAPON_PLASMA"
#define PAR_SOURCE_DAMAGES_WEAPON_VOLCANO        L"WEAPON_VOLCANO"
#define PAR_SOURCE_DAMAGES_WEAPON_LASER          L"WEAPON_LASER"
#define PAR_SOURCE_DAMAGES_WEAPON_HOMING_MISSILE L"WEAPON_HOMING_MISSILE"
#define PAR_SOURCE_DAMAGES_WEAPON_FLAMETHROWER   L"WEAPON_FLAMETHROWER"
#define PAR_SOURCE_DAMAGES_WEAPON_BIGBOOM        L"WEAPON_BIGBOOM"
#define PAR_SOURCE_DAMAGES_WEAPON_BOMB           L"WEAPON_BOMB"
#define PAR_SOURCE_DAMAGES_WEAPON_GUN            L"WEAPON_GUN"
#define PAR_SOURCE_DAMAGES_WEAPON_LIGHTENING     L"WEAPON_LIGHTENING"
#define PAR_SOURCE_DAMAGES_WEAPON_ABLAZE         L"WEAPON_ABLAZE"
#define PAR_SOURCE_DAMAGES_WEAPON_SHORTED        L"WEAPON_SHORTED"
#define PAR_SOURCE_DAMAGES_WEAPON_DEBRIS         L"WEAPON_DEBRIS"
#define PAR_SOURCE_DAMAGES_WEAPON_REPAIR         L"WEAPON_REPAIR"
#define PAR_SOURCE_DAMAGES_WEAPON_CANNON0        L"WEAPON_CANNON0"
#define PAR_SOURCE_DAMAGES_WEAPON_CANNON1        L"WEAPON_CANNON1"
#define PAR_SOURCE_DAMAGES_WEAPON_CANNON2        L"WEAPON_CANNON2"
#define PAR_SOURCE_DAMAGES_WEAPON_CANNON3        L"WEAPON_CANNON3"
#define PAR_SOURCE_RADAR                         L"Radars"
#define PAR_SOURCE_RADAR_ROBOT_RADIUS            L"RobotRadius"
#define PAR_SOURCE_RADAR_FLYER_RADIUS            L"FlyerRadius"
#define PAR_SOURCE_TIMINGS                       L"Timings"
#define PAR_SOURCE_TIMINGS_RESOURCES             L"Resources"
#define PAR_SOURCE_TIMINGS_TITAN                 L"RESOURCE_TITAN"
#define PAR_SOURCE_TIMINGS_ENERGY                L"RESOURCE_ENERGY"
#define PAR_SOURCE_TIMINGS_PLASMA                L"RESOURCE_PLASMA"
#define PAR_SOURCE_TIMINGS_ELECTRONICS           L"RESOURCE_ELECTRONICS"
#define PAR_SOURCE_TIMINGS_BASE                  L"RESOURCE_BASE"
#define PAR_SOURCE_TIMINGS_UNITS                 L"Units"
#define PAR_SOURCE_TIMINGS_ROBOT                 L"UNIT_ROBOT"
#define PAR_SOURCE_TIMINGS_FLYER                 L"UNIT_FLYER"
#define PAR_SOURCE_TIMINGS_TURRET                L"UNIT_TURRET"

#define PAR_SOURCE_TIMINGS_CAPTURE  L"Capture"
#define PAR_SOURCE_TIMINGS_ERASE    L"ERASE"
#define PAR_SOURCE_TIMINGS_PAINT    L"PAINT"
#define PAR_SOURCE_TIMINGS_ROLLBACK L"ROLLBACK"

#define PAR_SOURCE_TIMINGS_MAINTENANCE L"MAINTENANCE"

#define PAR_SOURCE_FLYER_ORDERS          L"FlyerOrders"
#define PAR_SOURCE_FLYER_ORDERS_GIVE_BOT L"GiveBot"

#define PAR_SOURCE_WATER         L"Water"
#define PAR_SOURCE_WATER_WATER   L"water"
#define PAR_SOURCE_WATER_MIRROR  L"mirror"
#define PAR_SOURCE_WATER_INSHORE L"inshore"

#define PAR_SOURCE_COOLDOWN L"Cooldown"
#define PAR_SOURCE_RADIUS   L"Radius"
#define PAR_SOURCE_OVERHEAT L"Overheat"
#define PAR_SOURCE_WEAPONS  L"Weapons"

#define PAR_SOURCE_MINIMAP           L"Minimap"
#define PAR_SOURCE_MINIMAP_POINT     L"point"
#define PAR_SOURCE_MINIMAP_ARROW     L"arrow"
#define PAR_SOURCE_MINIMAP_FLYER     L"flyer"
#define PAR_SOURCE_MINIMAP_ROBOT     L"robot"
#define PAR_SOURCE_MINIMAP_FACTORY   L"factory"
#define PAR_SOURCE_MINIMAP_BASE      L"base"
#define PAR_SOURCE_MINIMAP_TURRET    L"turret"
#define PAR_SOURCE_MINIMAP_FLYER_R   L"flyer_r"
#define PAR_SOURCE_MINIMAP_ROBOT_R   L"robot_r"
#define PAR_SOURCE_MINIMAP_FACTORY_R L"factory_r"
#define PAR_SOURCE_MINIMAP_BASE_R    L"base_r"
#define PAR_SOURCE_MINIMAP_TURRET_R  L"turret_r"

#define PAR_SOURCE_HINTS         L"Hints"
#define PAR_SOURCE_HINTS_BITMAPS L"Bitmaps"
#define PAR_SOURCE_HINTS_SOURCE  L"Source"
#define PAR_SOURCE_HINTS_LT      L"LeftTop"
#define PAR_SOURCE_HINTS_T       L"Top"
#define PAR_SOURCE_HINTS_RT      L"RightTop"
#define PAR_SOURCE_HINTS_L       L"Left"
#define PAR_SOURCE_HINTS_C       L"Center"
#define PAR_SOURCE_HINTS_R       L"Right"
#define PAR_SOURCE_HINTS_LB      L"LeftBottom"
#define PAR_SOURCE_HINTS_B       L"Bottom"
#define PAR_SOURCE_HINTS_RB      L"RightBottom"

#define PAR_SOURCE_OVERHEAT_WHP_VOLCANO         L"WHP_VOLCANO"
#define PAR_SOURCE_OVERHEAT_WEAPON_VOLCANO_HEAT L"WEAPON_VOLCANO_HEAT"
#define PAR_SOURCE_OVERHEAT_WCP_VOLCANO         L"WCP_VOLCANO"
#define PAR_SOURCE_OVERHEAT_WEAPON_VOLCANO_COOL L"WEAPON_VOLCANO_COOL"

#define PAR_SOURCE_OVERHEAT_WHP_PLASMA         L"WHP_PLASMA"
#define PAR_SOURCE_OVERHEAT_WEAPON_PLASMA_HEAT L"WEAPON_PLASMA_HEAT"
#define PAR_SOURCE_OVERHEAT_WCP_PLASMA         L"WCP_PLASMA"
#define PAR_SOURCE_OVERHEAT_WEAPON_PLASMA_COOL L"WEAPON_PLASMA_COOL"

#define PAR_SOURCE_OVERHEAT_WHP_LASER         L"WHP_LASER"
#define PAR_SOURCE_OVERHEAT_WEAPON_LASER_HEAT L"WEAPON_LASER_HEAT"
#define PAR_SOURCE_OVERHEAT_WCP_LASER         L"WCP_LASER"
#define PAR_SOURCE_OVERHEAT_WEAPON_LASER_COOL L"WEAPON_LASER_COOL"

#define PAR_SOURCE_OVERHEAT_WHP_HOMING_MISSILE         L"WHP_HOMING_MISSILE"
#define PAR_SOURCE_OVERHEAT_WEAPON_HOMING_MISSILE_HEAT L"WEAPON_HOMING_MISSILE_HEAT"
#define PAR_SOURCE_OVERHEAT_WCP_HOMING_MISSILE         L"WCP_HOMING_MISSILE"
#define PAR_SOURCE_OVERHEAT_WEAPON_HOMING_MISSILE_COOL L"WEAPON_HOMING_MISSILE_COOL"

#define PAR_SOURCE_OVERHEAT_WHP_FLAMETHROWER         L"WHP_FLAMETHROWER"
#define PAR_SOURCE_OVERHEAT_WEAPON_FLAMETHROWER_HEAT L"WEAPON_FLAMETHROWER_HEAT"
#define PAR_SOURCE_OVERHEAT_WCP_FLAMETHROWER         L"WCP_FLAMETHROWER"
#define PAR_SOURCE_OVERHEAT_WEAPON_FLAMETHROWER_COOL L"WEAPON_FLAMETHROWER_COOL"

#define PAR_SOURCE_OVERHEAT_WHP_BOMB         L"WHP_BOMB"
#define PAR_SOURCE_OVERHEAT_WEAPON_BOMB_HEAT L"WEAPON_BOMB_HEAT"
#define PAR_SOURCE_OVERHEAT_WCP_BOMB         L"WCP_BOMB"
#define PAR_SOURCE_OVERHEAT_WEAPON_BOMB_COOL L"WEAPON_BOMB_COOL"

#define PAR_SOURCE_OVERHEAT_WHP_GUN         L"WHP_GUN"
#define PAR_SOURCE_OVERHEAT_WEAPON_GUN_HEAT L"WEAPON_GUN_HEAT"
#define PAR_SOURCE_OVERHEAT_WCP_GUN         L"WCP_GUN"
#define PAR_SOURCE_OVERHEAT_WEAPON_GUN_COOL L"WEAPON_GUN_COOL"

#define PAR_SOURCE_OVERHEAT_WHP_LIGHTENING         L"WHP_LIGHTENING"
#define PAR_SOURCE_OVERHEAT_WEAPON_LIGHTENING_HEAT L"WEAPON_LIGHTENING_HEAT"
#define PAR_SOURCE_OVERHEAT_WCP_LIGHTENING         L"WCP_LIGHTENING"
#define PAR_SOURCE_OVERHEAT_WEAPON_LIGHTENING_COOL L"WEAPON_LIGHTENING_COOL"

#define PAR_SOURCE_PRICE L"Price"

#define PAR_SOURCE_PRICE_HEAD              L"Head"
#define PAR_SOURCE_PRICE_HEAD1_TITAN       L"HEAD1_TITAN"
#define PAR_SOURCE_PRICE_HEAD1_ELECTRONICS L"HEAD1_ELECTRONICS"
#define PAR_SOURCE_PRICE_HEAD1_ENERGY      L"HEAD1_ENERGY"
#define PAR_SOURCE_PRICE_HEAD1_PLASM       L"HEAD1_PLASM"

#define PAR_SOURCE_PRICE_HEAD2_TITAN       L"HEAD2_TITAN"
#define PAR_SOURCE_PRICE_HEAD2_ELECTRONICS L"HEAD2_ELECTRONICS"
#define PAR_SOURCE_PRICE_HEAD2_ENERGY      L"HEAD2_ENERGY"
#define PAR_SOURCE_PRICE_HEAD2_PLASM       L"HEAD2_PLASM"

#define PAR_SOURCE_PRICE_HEAD3_TITAN       L"HEAD3_TITAN"
#define PAR_SOURCE_PRICE_HEAD3_ELECTRONICS L"HEAD3_ELECTRONICS"
#define PAR_SOURCE_PRICE_HEAD3_ENERGY      L"HEAD3_ENERGY"
#define PAR_SOURCE_PRICE_HEAD3_PLASM       L"HEAD3_PLASM"

#define PAR_SOURCE_PRICE_HEAD4_TITAN       L"HEAD4_TITAN"
#define PAR_SOURCE_PRICE_HEAD4_ELECTRONICS L"HEAD4_ELECTRONICS"
#define PAR_SOURCE_PRICE_HEAD4_ENERGY      L"HEAD4_ENERGY"
#define PAR_SOURCE_PRICE_HEAD4_PLASM       L"HEAD4_PLASM"

#define PAR_SOURCE_PRICE_ARMOR              L"Armor"
#define PAR_SOURCE_PRICE_ARMOR1_TITAN       L"ARMOR1_TITAN"
#define PAR_SOURCE_PRICE_ARMOR1_ELECTRONICS L"ARMOR1_ELECTRONICS"
#define PAR_SOURCE_PRICE_ARMOR1_ENERGY      L"ARMOR1_ENERGY"
#define PAR_SOURCE_PRICE_ARMOR1_PLASM       L"ARMOR1_PLASM"

#define PAR_SOURCE_PRICE_ARMOR2_TITAN       L"ARMOR2_TITAN"
#define PAR_SOURCE_PRICE_ARMOR2_ELECTRONICS L"ARMOR2_ELECTRONICS"
#define PAR_SOURCE_PRICE_ARMOR2_ENERGY      L"ARMOR2_ENERGY"
#define PAR_SOURCE_PRICE_ARMOR2_PLASM       L"ARMOR2_PLASM"

#define PAR_SOURCE_PRICE_ARMOR3_TITAN       L"ARMOR3_TITAN"
#define PAR_SOURCE_PRICE_ARMOR3_ELECTRONICS L"ARMOR3_ELECTRONICS"
#define PAR_SOURCE_PRICE_ARMOR3_ENERGY      L"ARMOR3_ENERGY"
#define PAR_SOURCE_PRICE_ARMOR3_PLASM       L"ARMOR3_PLASM"

#define PAR_SOURCE_PRICE_ARMOR4_TITAN       L"ARMOR4_TITAN"
#define PAR_SOURCE_PRICE_ARMOR4_ELECTRONICS L"ARMOR4_ELECTRONICS"
#define PAR_SOURCE_PRICE_ARMOR4_ENERGY      L"ARMOR4_ENERGY"
#define PAR_SOURCE_PRICE_ARMOR4_PLASM       L"ARMOR4_PLASM"

#define PAR_SOURCE_PRICE_ARMOR5_TITAN       L"ARMOR5_TITAN"
#define PAR_SOURCE_PRICE_ARMOR5_ELECTRONICS L"ARMOR5_ELECTRONICS"
#define PAR_SOURCE_PRICE_ARMOR5_ENERGY      L"ARMOR5_ENERGY"
#define PAR_SOURCE_PRICE_ARMOR5_PLASM       L"ARMOR5_PLASM"

#define PAR_SOURCE_PRICE_ARMOR6_TITAN       L"ARMOR6_TITAN"
#define PAR_SOURCE_PRICE_ARMOR6_ELECTRONICS L"ARMOR6_ELECTRONICS"
#define PAR_SOURCE_PRICE_ARMOR6_ENERGY      L"ARMOR6_ENERGY"
#define PAR_SOURCE_PRICE_ARMOR6_PLASM       L"ARMOR6_PLASM"

#define PAR_SOURCE_PRICE_WEAPON              L"Weapon"
#define PAR_SOURCE_PRICE_WEAPON1_TITAN       L"WEAPON1_TITAN"
#define PAR_SOURCE_PRICE_WEAPON1_ELECTRONICS L"WEAPON1_ELECTRONICS"
#define PAR_SOURCE_PRICE_WEAPON1_ENERGY      L"WEAPON1_ENERGY"
#define PAR_SOURCE_PRICE_WEAPON1_PLASM       L"WEAPON1_PLASM"

#define PAR_SOURCE_PRICE_WEAPON2_TITAN       L"WEAPON2_TITAN"
#define PAR_SOURCE_PRICE_WEAPON2_ELECTRONICS L"WEAPON2_ELECTRONICS"
#define PAR_SOURCE_PRICE_WEAPON2_ENERGY      L"WEAPON2_ENERGY"
#define PAR_SOURCE_PRICE_WEAPON2_PLASM       L"WEAPON2_PLASM"

#define PAR_SOURCE_PRICE_WEAPON3_TITAN       L"WEAPON3_TITAN"
#define PAR_SOURCE_PRICE_WEAPON3_ELECTRONICS L"WEAPON3_ELECTRONICS"
#define PAR_SOURCE_PRICE_WEAPON3_ENERGY      L"WEAPON3_ENERGY"
#define PAR_SOURCE_PRICE_WEAPON3_PLASM       L"WEAPON3_PLASM"

#define PAR_SOURCE_PRICE_WEAPON4_TITAN       L"WEAPON4_TITAN"
#define PAR_SOURCE_PRICE_WEAPON4_ELECTRONICS L"WEAPON4_ELECTRONICS"
#define PAR_SOURCE_PRICE_WEAPON4_ENERGY      L"WEAPON4_ENERGY"
#define PAR_SOURCE_PRICE_WEAPON4_PLASM       L"WEAPON4_PLASM"

#define PAR_SOURCE_PRICE_WEAPON5_TITAN       L"WEAPON5_TITAN"
#define PAR_SOURCE_PRICE_WEAPON5_ELECTRONICS L"WEAPON5_ELECTRONICS"
#define PAR_SOURCE_PRICE_WEAPON5_ENERGY      L"WEAPON5_ENERGY"
#define PAR_SOURCE_PRICE_WEAPON5_PLASM       L"WEAPON5_PLASM"

#define PAR_SOURCE_PRICE_WEAPON6_TITAN       L"WEAPON6_TITAN"
#define PAR_SOURCE_PRICE_WEAPON6_ELECTRONICS L"WEAPON6_ELECTRONICS"
#define PAR_SOURCE_PRICE_WEAPON6_ENERGY      L"WEAPON6_ENERGY"
#define PAR_SOURCE_PRICE_WEAPON6_PLASM       L"WEAPON6_PLASM"

#define PAR_SOURCE_PRICE_WEAPON7_TITAN       L"WEAPON7_TITAN"
#define PAR_SOURCE_PRICE_WEAPON7_ELECTRONICS L"WEAPON7_ELECTRONICS"
#define PAR_SOURCE_PRICE_WEAPON7_ENERGY      L"WEAPON7_ENERGY"
#define PAR_SOURCE_PRICE_WEAPON7_PLASM       L"WEAPON7_PLASM"

#define PAR_SOURCE_PRICE_WEAPON8_TITAN       L"WEAPON8_TITAN"
#define PAR_SOURCE_PRICE_WEAPON8_ELECTRONICS L"WEAPON8_ELECTRONICS"
#define PAR_SOURCE_PRICE_WEAPON8_ENERGY      L"WEAPON8_ENERGY"
#define PAR_SOURCE_PRICE_WEAPON8_PLASM       L"WEAPON8_PLASM"

#define PAR_SOURCE_PRICE_WEAPON9_TITAN       L"WEAPON9_TITAN"
#define PAR_SOURCE_PRICE_WEAPON9_ELECTRONICS L"WEAPON9_ELECTRONICS"
#define PAR_SOURCE_PRICE_WEAPON9_ENERGY      L"WEAPON9_ENERGY"
#define PAR_SOURCE_PRICE_WEAPON9_PLASM       L"WEAPON9_PLASM"

#define PAR_SOURCE_PRICE_WEAPON10_TITAN       L"WEAPON10_TITAN"
#define PAR_SOURCE_PRICE_WEAPON10_ELECTRONICS L"WEAPON10_ELECTRONICS"
#define PAR_SOURCE_PRICE_WEAPON10_ENERGY      L"WEAPON10_ENERGY"
#define PAR_SOURCE_PRICE_WEAPON10_PLASM       L"WEAPON10_PLASM"

#define PAR_SOURCE_PRICE_CHASSIS              L"Chassis"
#define PAR_SOURCE_PRICE_CHASSIS1_TITAN       L"CHASSIS1_TITAN"
#define PAR_SOURCE_PRICE_CHASSIS1_ELECTRONICS L"CHASSIS1_ELECTRONICS"
#define PAR_SOURCE_PRICE_CHASSIS1_ENERGY      L"CHASSIS1_ENERGY"
#define PAR_SOURCE_PRICE_CHASSIS1_PLASM       L"CHASSIS1_PLASM"

#define PAR_SOURCE_PRICE_CHASSIS2_TITAN       L"CHASSIS2_TITAN"
#define PAR_SOURCE_PRICE_CHASSIS2_ELECTRONICS L"CHASSIS2_ELECTRONICS"
#define PAR_SOURCE_PRICE_CHASSIS2_ENERGY      L"CHASSIS2_ENERGY"
#define PAR_SOURCE_PRICE_CHASSIS2_PLASM       L"CHASSIS2_PLASM"

#define PAR_SOURCE_PRICE_CHASSIS3_TITAN       L"CHASSIS3_TITAN"
#define PAR_SOURCE_PRICE_CHASSIS3_ELECTRONICS L"CHASSIS3_ELECTRONICS"
#define PAR_SOURCE_PRICE_CHASSIS3_ENERGY      L"CHASSIS3_ENERGY"
#define PAR_SOURCE_PRICE_CHASSIS3_PLASM       L"CHASSIS3_PLASM"

#define PAR_SOURCE_PRICE_CHASSIS4_TITAN       L"CHASSIS4_TITAN"
#define PAR_SOURCE_PRICE_CHASSIS4_ELECTRONICS L"CHASSIS4_ELECTRONICS"
#define PAR_SOURCE_PRICE_CHASSIS4_ENERGY      L"CHASSIS4_ENERGY"
#define PAR_SOURCE_PRICE_CHASSIS4_PLASM       L"CHASSIS4_PLASM"

#define PAR_SOURCE_PRICE_CHASSIS5_TITAN       L"CHASSIS5_TITAN"
#define PAR_SOURCE_PRICE_CHASSIS5_ELECTRONICS L"CHASSIS5_ELECTRONICS"
#define PAR_SOURCE_PRICE_CHASSIS5_ENERGY      L"CHASSIS5_ENERGY"
#define PAR_SOURCE_PRICE_CHASSIS5_PLASM       L"CHASSIS5_PLASM"

#define PAR_SOURCE_CAMERA          L"Camera"
#define PAR_SOURCE_CAMERA_STRATEGY L"Strategy"
#define PAR_SOURCE_CAMERA_INROBOT  L"InRobot"

#define PAR_SOURCE_CAMERA_WHEELSTEP   L"CamMouseWheelStep"
#define PAR_SOURCE_CAMERA_ROTSPEEDX   L"CamRotSpeedX"
#define PAR_SOURCE_CAMERA_ROTSPEEDZ   L"CamRotSpeedZ"
#define PAR_SOURCE_CAMERA_ROTANGLEMIN L"CamRotAngleMin"
#define PAR_SOURCE_CAMERA_ROTANGLEMAX L"CamRotAngleMax"
#define PAR_SOURCE_CAMERA_DISTMIN     L"CamDistMin"
#define PAR_SOURCE_CAMERA_DISTMAX     L"CamDistMax"
#define PAR_SOURCE_CAMERA_ANGLEPARAM  L"CamAngleParam"
#define PAR_SOURCE_CAMERA_HEIGHT      L"CamHeight"

#define PAR_SOURCE_CAMERA_BASEANGLEZ  L"CamBaseAngleZ"
#define PAR_SOURCE_CAMERA_MOVESPEED   L"CamMoveSpeed"
#define PAR_SOURCE_CAMERA_INROBOTFWD0 L"CamInRobotForward0"
#define PAR_SOURCE_CAMERA_INROBOTFWD1 L"CamInRobotForward1"

#define PAR_SOURCE_CANNONS                  L"Cannons"
#define PAR_SOURCE_CANNONS_MAX_TOP_ANGLE    L"MaxTopAngle"
#define PAR_SOURCE_CANNONS_MAX_BOTTOM_ANGLE L"MaxBottomAngle"
#define PAR_SOURCE_CANNONS_WEAPON           L"Weapon"
#define PAR_SOURCE_CANNONS_ROTATION         L"Rotation"
#define PAR_SOURCE_CANNONS_RADIUS           L"Radius"
#define PAR_SOURCE_CANNONS_COOLDOWN         L"CoolDown"

//#define IF_LABELS_FILE                          L"cfg\\labels.txt"
#define PAR_SOURCE_ITEMS_LABELS       L"Items"
#define PAR_SOURCE_ITEMS_DESCRIPTIONS L"Descriptions"

#define PAR_SOURCE_W1_CHAR  L"w1_char"
#define PAR_SOURCE_W2_CHAR  L"w2_char"
#define PAR_SOURCE_W3_CHAR  L"w3_char"
#define PAR_SOURCE_W4_CHAR  L"w4_char"
#define PAR_SOURCE_W5_CHAR  L"w5_char"
#define PAR_SOURCE_W6_CHAR  L"w6_char"
#define PAR_SOURCE_W7_CHAR  L"w7_char"
#define PAR_SOURCE_W8_CHAR  L"w8_char"
#define PAR_SOURCE_W9_CHAR  L"w9_char"
#define PAR_SOURCE_W10_CHAR L"w10_char"

#define PAR_SOURCE_HE1_CHAR L"he1_char"
#define PAR_SOURCE_HE2_CHAR L"he2_char"
#define PAR_SOURCE_HE3_CHAR L"he3_char"
#define PAR_SOURCE_HE4_CHAR L"he4_char"

#define PAR_SOURCE_HU1_CHAR L"hu1_char"
#define PAR_SOURCE_HU2_CHAR L"hu2_char"
#define PAR_SOURCE_HU3_CHAR L"hu3_char"
#define PAR_SOURCE_HU4_CHAR L"hu4_char"
#define PAR_SOURCE_HU5_CHAR L"hu5_char"
#define PAR_SOURCE_HU6_CHAR L"hu6_char"

#define PAR_SOURCE_CH1_CHAR L"ch1_char"
#define PAR_SOURCE_CH2_CHAR L"ch2_char"
#define PAR_SOURCE_CH3_CHAR L"ch3_char"
#define PAR_SOURCE_CH4_CHAR L"ch4_char"
#define PAR_SOURCE_CH5_CHAR L"ch5_char"

#define PAR_SOURCE_W1_DESCR  L"w1_descr"
#define PAR_SOURCE_W2_DESCR  L"w2_descr"
#define PAR_SOURCE_W3_DESCR  L"w3_descr"
#define PAR_SOURCE_W4_DESCR  L"w4_descr"
#define PAR_SOURCE_W5_DESCR  L"w5_descr"
#define PAR_SOURCE_W6_DESCR  L"w6_descr"
#define PAR_SOURCE_W7_DESCR  L"w7_descr"
#define PAR_SOURCE_W8_DESCR  L"w8_descr"
#define PAR_SOURCE_W9_DESCR  L"w9_descr"
#define PAR_SOURCE_W10_DESCR L"w10_descr"

#define PAR_SOURCE_HE1_DESCR L"he1_descr"
#define PAR_SOURCE_HE2_DESCR L"he2_descr"
#define PAR_SOURCE_HE3_DESCR L"he3_descr"
#define PAR_SOURCE_HE4_DESCR L"he4_descr"

#define PAR_SOURCE_HU1_DESCR L"hu1_descr"
#define PAR_SOURCE_HU2_DESCR L"hu2_descr"
#define PAR_SOURCE_HU3_DESCR L"hu3_descr"
#define PAR_SOURCE_HU4_DESCR L"hu4_descr"
#define PAR_SOURCE_HU5_DESCR L"hu5_descr"
#define PAR_SOURCE_HU6_DESCR L"hu6_descr"

#define PAR_SOURCE_CH1_DESCR L"ch1_descr"
#define PAR_SOURCE_CH2_DESCR L"ch2_descr"
#define PAR_SOURCE_CH3_DESCR L"ch3_descr"
#define PAR_SOURCE_CH4_DESCR L"ch4_descr"
#define PAR_SOURCE_CH5_DESCR L"ch5_descr"

#define PAR_SOURCE_CHARS L"Chars"

#define PAR_SOURCE_ARMOR6_STRUCTURE      L"ARMOR6_STRUCTURE"
#define PAR_SOURCE_ARMOR6_ROTATION_SPEED L"ARMOR6_ROTATION_SPEED"

#define PAR_SOURCE_ARMOR1_STRUCTURE      L"ARMOR1_STRUCTURE"
#define PAR_SOURCE_ARMOR1_ROTATION_SPEED L"ARMOR1_ROTATION_SPEED"

#define PAR_SOURCE_ARMOR2_STRUCTURE      L"ARMOR2_STRUCTURE"
#define PAR_SOURCE_ARMOR2_ROTATION_SPEED L"ARMOR2_ROTATION_SPEED"

#define PAR_SOURCE_ARMOR3_STRUCTURE      L"ARMOR3_STRUCTURE"
#define PAR_SOURCE_ARMOR3_ROTATION_SPEED L"ARMOR3_ROTATION_SPEED"

#define PAR_SOURCE_ARMOR4_STRUCTURE      L"ARMOR4_STRUCTURE"
#define PAR_SOURCE_ARMOR4_ROTATION_SPEED L"ARMOR4_ROTATION_SPEED"

#define PAR_SOURCE_ARMOR5_STRUCTURE      L"ARMOR5_STRUCTURE"
#define PAR_SOURCE_ARMOR5_ROTATION_SPEED L"ARMOR5_ROTATION_SPEED"

#define PAR_SOURCE_CHASSIS1_STRUCTURE          L"CHASSIS1_STRUCTURE"
#define PAR_SOURCE_CHASSIS1_ROTATION_SPEED     L"CHASSIS1_ROTATION_SPEED"
#define PAR_SOURCE_CHASSIS1_MOVE_SPEED         L"CHASSIS1_MOVE_SPEED"
#define PAR_SOURCE_CHASSIS1_MOVE_WATER_CORR    L"CHASSIS1_MOVE_WATER_CORR"
#define PAR_SOURCE_CHASSIS1_MOVE_SLOPE_CORR_UP L"CHASSIS1_MOVE_SLOPE_CORR_UP"
#define PAR_SOURCE_CHASSIS1_MOVE_SLOPE_CORR_DN L"CHASSIS1_MOVE_SLOPE_CORR_DN"

#define PAR_SOURCE_CHASSIS2_STRUCTURE          L"CHASSIS2_STRUCTURE"
#define PAR_SOURCE_CHASSIS2_ROTATION_SPEED     L"CHASSIS2_ROTATION_SPEED"
#define PAR_SOURCE_CHASSIS2_MOVE_SPEED         L"CHASSIS2_MOVE_SPEED"
#define PAR_SOURCE_CHASSIS2_MOVE_WATER_CORR    L"CHASSIS2_MOVE_WATER_CORR"
#define PAR_SOURCE_CHASSIS2_MOVE_SLOPE_CORR_UP L"CHASSIS2_MOVE_SLOPE_CORR_UP"
#define PAR_SOURCE_CHASSIS2_MOVE_SLOPE_CORR_DN L"CHASSIS2_MOVE_SLOPE_CORR_DN"

#define PAR_SOURCE_CHASSIS3_STRUCTURE          L"CHASSIS3_STRUCTURE"
#define PAR_SOURCE_CHASSIS3_ROTATION_SPEED     L"CHASSIS3_ROTATION_SPEED"
#define PAR_SOURCE_CHASSIS3_MOVE_SPEED         L"CHASSIS3_MOVE_SPEED"
#define PAR_SOURCE_CHASSIS3_MOVE_WATER_CORR    L"CHASSIS3_MOVE_WATER_CORR"
#define PAR_SOURCE_CHASSIS3_MOVE_SLOPE_CORR_UP L"CHASSIS3_MOVE_SLOPE_CORR_UP"
#define PAR_SOURCE_CHASSIS3_MOVE_SLOPE_CORR_DN L"CHASSIS3_MOVE_SLOPE_CORR_DN"

#define PAR_SOURCE_CHASSIS4_STRUCTURE          L"CHASSIS4_STRUCTURE"
#define PAR_SOURCE_CHASSIS4_ROTATION_SPEED     L"CHASSIS4_ROTATION_SPEED"
#define PAR_SOURCE_CHASSIS4_MOVE_SPEED         L"CHASSIS4_MOVE_SPEED"
#define PAR_SOURCE_CHASSIS4_MOVE_WATER_CORR    L"CHASSIS4_MOVE_WATER_CORR"
#define PAR_SOURCE_CHASSIS4_MOVE_SLOPE_CORR_UP L"CHASSIS4_MOVE_SLOPE_CORR_UP"
#define PAR_SOURCE_CHASSIS4_MOVE_SLOPE_CORR_DN L"CHASSIS4_MOVE_SLOPE_CORR_DN"

#define PAR_SOURCE_CHASSIS5_STRUCTURE          L"CHASSIS5_STRUCTURE"
#define PAR_SOURCE_CHASSIS5_ROTATION_SPEED     L"CHASSIS5_ROTATION_SPEED"
#define PAR_SOURCE_CHASSIS5_MOVE_SPEED         L"CHASSIS5_MOVE_SPEED"
#define PAR_SOURCE_CHASSIS5_MOVE_WATER_CORR    L"CHASSIS5_MOVE_WATER_CORR"
#define PAR_SOURCE_CHASSIS5_MOVE_SLOPE_CORR_UP L"CHASSIS5_MOVE_SLOPE_CORR_UP"
#define PAR_SOURCE_CHASSIS5_MOVE_SLOPE_CORR_DN L"CHASSIS5_MOVE_SLOPE_CORR_DN"

#define CURSOR_ARROW        L"arrow"
#define CURSOR_CROSS_BLUE   L"cross_blue"
#define CURSOR_CROSS_RED    L"cross_red"
#define CURSOR_CROSS_YELLOW L"cross_yellow"
#define CURSOR_STAR         L"star"

#define FOLDER_NAME_CACHE       "Cache"
#define FOLDER_NAME_SCREENSHOTS "Screenshots"
#define FILE_NAME_SCREENSHOT    "Shot"

// interface

// system
#define IF_LABELS_BLOCKPAR     L"AllLabels"
#define IF_LABELS              L"Labels"
#define IF_LABELS_TEXT         L"LabelsText"
#define IF_STATE_STATIC_LABEL  L"StateStaticLabel"
#define IF_STATE_DYNAMIC_LABEL L"StateDynamicLabel"
#define IF_STATIC_LABEL        L"StaticLabel"
#define IF_LABEL_PARAMS        L"Params"

#define IF_STATE_NORMAL            L"sNormal"
#define IF_STATE_FOCUSED           L"sFocused"
#define IF_STATE_PRESSED           L"sPressed"
#define IF_STATE_DISABLED          L"sDisabled"
#define IF_STATE_PRESSED_UNFOCUSED L"sPressedUnfocused"
#define IF_PATH                    L"cfg\\robots\\iface.txt"

#define IF_ANIMATION            L"Animation"
#define IF_ANIMATION_TEX        L"Texture"
#define IF_ANIMATION_TEX_WIDTH  L"TexWidth"
#define IF_ANIMATION_TEX_HEIGHT L"TexHeight"
#define IF_ANIMATION_FRAMES     L"Frames"

// Popupmenu

#define IF_POPUP_MENU L"PopupMenu"
// Main
#define IF_MAIN           L"Main"
#define IF_CALL_FROM_HELL L"callhell"
#define IF_LIVES_LABEL    L"lives"
#define IF_NAME_LABEL     L"name"
#define IF_RHEAD_LABEL    L"rhead"
#define IF_RHULL_LABEL    L"rhull"
#define IF_RCHAS_LABEL    L"rchas"
#define IF_RWGHT_LABEL    L"rwght"
#define IF_RSPEED_LABEL   L"rspeed"

#define IF_DOTLINE               L"dotln"
#define IF_OVER_HEAT             L"ovhe"
#define IF_WEAPON_ROCKET_ON      L"wron"
#define IF_WEAPON_ROCKET_OFF     L"wrof"
#define IF_WEAPON_MINOMET_ON     L"wmin"
#define IF_WEAPON_MINOMET_OFF    L"wmif"
#define IF_WEAPON_BOOM_ON        L"wbon"
#define IF_WEAPON_BOOM_OFF       L"wbof"
#define IF_WEAPON_MACHINEGUN_ON  L"wman"
#define IF_WEAPON_MACHINEGUN_OFF L"wmaf"
#define IF_WEAPON_CANNON_ON      L"wcan"
#define IF_WEAPON_CANNON_OFF     L"wcaf"
#define IF_WEAPON_FIRE_ON        L"wfin"
#define IF_WEAPON_FIRE_OFF       L"wfif"
#define IF_WEAPON_LASER_ON       L"wlan"
#define IF_WEAPON_LASER_OFF      L"wlaf"
#define IF_WEAPON_ELECTRO_ON     L"weln"
#define IF_WEAPON_ELECTRO_OFF    L"welf"
#define IF_WEAPON_PLASMA_ON      L"wpln"
#define IF_WEAPON_PLASMA_OFF     L"wplf"
#define IF_WEAPON_REPAIR_ON      L"wren"
#define IF_WEAPON_REPAIR_OFF     L"wref"

#define IF_ORDER_GLOW  L"osel"
#define IF_GROUP_GLOW  L"gsel"
#define IF_GROUP_RAMKA L"gram"

#define IF_AUTO_SEL_1 L"kadr1"
#define IF_AUTO_SEL_2 L"kadr2"
#define IF_AUTO_SEL_3 L"kadr3"
#define IF_AUTO_SEL_4 L"kadr4"
#define IF_AUTO_SEL_5 L"kadr5"
#define IF_AUTO_SEL_6 L"kadr6"
#define IF_AUTO_SEL_7 L"kadr7"
#define IF_AUTO_SEL_8 L"kadr8"

#define IF_MANUAL_BG  L"manbg"
#define IF_EVIL_LAMP1 L"ela1"
#define IF_EVIL_LAMP2 L"ela2"
#define IF_EVIL_LAMP3 L"ela3"

#define IF_MAIN_PANEL1 L"mp1"
#define IF_MAIN_PANEL2 L"mp2"

#define IF_MAIN_HP L"hp"  // hit points

#define IF_ORDER_STOP    L"ost"
#define IF_ORDER_MOVE    L"ogo"
#define IF_ORDER_PATROL  L"opa"
#define IF_ORDER_FIRE    L"ofi"
#define IF_ORDER_CAPTURE L"oca"
#define IF_ORDER_CANCEL  L"ocan"
#define IF_ORDER_REPAIR  L"orep"
#define IF_ORDER_BOMB    L"obomb"

#define IF_LEAVE_ROBOT L"lero"
#define IF_ENTER_ROBOT L"inro"

#define IF_AORDER_CAPTURE_OFF L"oacapf"
#define IF_AORDER_CAPTURE_ON  L"oacapn"
#define IF_AORDER_PROTECT_OFF L"oafcf"
#define IF_AORDER_PROTECT_ON  L"oafcn"
#define IF_AORDER_FROBOT_OFF  L"oafrf"
#define IF_AORDER_FROBOT_ON   L"oafrn"

#define IF_ZAGLUSHKA1 L"zagl1"

#define IF_TITAN_PLANT   L"titpl"
#define IF_PLASMA_PLANT  L"plaspl"
#define IF_ELECTRO_PLANT L"elecpl"
#define IF_ENERGY_PLANT  L"batpl"
#define IF_REPAIR_PLANT  L"reppl"
#define IF_BASE_PLANT    L"basepl"

#define IF_BASE_LINE L"baseln"

#define IF_BUILD_RO     L"buro"
#define IF_BUILD_HE     L"buhe"
#define IF_BUILD_CA     L"buca"
#define IF_BUILD_REPAIR L"bure"

#define IF_BUILD_TUR1 L"tur1"
#define IF_BUILD_TUR2 L"tur2"
#define IF_BUILD_TUR3 L"tur3"
#define IF_BUILD_TUR4 L"tur4"

#define IF_TURRETS_MAX  L"turmax"
#define IF_TURRETS_HAVE L"turhav"

#define IF_STACK_ICON  L"sticon"
#define IF_STACK_OTHER L"stother"

#define IF_TURRET_SMALL1 L"tsm1"
#define IF_TURRET_SMALL2 L"tsm2"
#define IF_TURRET_SMALL3 L"tsm3"
#define IF_TURRET_SMALL4 L"tsm4"

#define IF_TURRET_MED1 L"tmd1"
#define IF_TURRET_MED2 L"tmd2"
#define IF_TURRET_MED3 L"tmd3"
#define IF_TURRET_MED4 L"tmd4"

// Radar
#define IF_RADAR    L"Radar"
#define IF_RADAR_PN L"rad"

// Mini-map
#define IF_MINI_MAP         L"MiniM"
#define IF_MAP_ZOOM_IN      L"zi"
#define IF_MAP_ZOOM_OUT     L"zo"
#define IF_MAP_PANEL        L"mmp"
#define IF_SHOWROBOTS_PANEL L"srpan"
#define IF_SHOWROBOTS_BUTT  L"srb"

// Top (less :)))
#define IF_TOP              L"Top"
#define IF_TOP_PANEL1       L"tp1"
#define IF_MAIN_MENU_BUTTON L"mm"
#define IF_TITAN_LABEL      L"tit"
#define IF_ELECTRO_LABEL    L"elect"
#define IF_ENERGY_LABEL     L"energ"
#define IF_PLASMA_LABEL     L"plasm"
#define IF_RVALUE_LABEL     L"rval"

// Base
#define IF_BASE L"Base"

#define IF_BASE_CONSTRUCTION_LEFT  L"conl"
#define IF_BASE_CONSTRUCTION_RIGHT L"conr"
#define IF_BASE_CONSTRUCTION_FOOT  L"conf"

#define IF_BASE_CONST_CANCEL L"cocan"
#define IF_BASE_CONST_BUILD  L"cobuild"

#define IF_BASE_CHASSIS1 L"chas1"
#define IF_BASE_CHASSIS2 L"chas2"
#define IF_BASE_CHASSIS3 L"chas3"
#define IF_BASE_CHASSIS4 L"chas4"
#define IF_BASE_CHASSIS5 L"chas5"

#define IF_BASE_HULL1 L"hull1"
#define IF_BASE_HULL2 L"hull2"
#define IF_BASE_HULL3 L"hull3"
#define IF_BASE_HULL4 L"hull4"
#define IF_BASE_HULL5 L"hull5"
#define IF_BASE_HULL6 L"hull6"

#define IF_BASE_HEAD1 L"head1"
#define IF_BASE_HEAD2 L"head2"
#define IF_BASE_HEAD3 L"head3"
#define IF_BASE_HEAD4 L"head4"

#define IF_BASE_WEAPON1  L"weap1"
#define IF_BASE_WEAPON2  L"weap2"
#define IF_BASE_WEAPON3  L"weap3"
#define IF_BASE_WEAPON4  L"weap4"
#define IF_BASE_WEAPON5  L"weap5"
#define IF_BASE_WEAPON6  L"weap6"
#define IF_BASE_WEAPON7  L"weap7"
#define IF_BASE_WEAPON8  L"weap8"
#define IF_BASE_WEAPON9  L"weap9"
#define IF_BASE_WEAPON10 L"weap10"

#define IF_BASE_HEAD_EMPTY   L"heade"
#define IF_BASE_WEAPON_EMPTY L"weape"

#define IF_BASE_PILON1 L"pi1"
#define IF_BASE_PILON2 L"pi2"
#define IF_BASE_PILON3 L"pi3"
#define IF_BASE_PILON4 L"pi4"
#define IF_BASE_PILON5 L"pi5"

#define IF_BASE_PILON_HEAD    L"pihe"
#define IF_BASE_PILON_HULL    L"pihu"
#define IF_BASE_PILON_CHASSIS L"pich"

#define IF_BASE_TITAN_IMAGE       L"titan"
#define IF_BASE_ELECTRONICS_IMAGE L"electr"
#define IF_BASE_ENERGY_IMAGE      L"energy"
#define IF_BASE_PLASMA_IMAGE      L"plasma"

#define IF_BASE_TITAN_SUMM       L"titans"
#define IF_BASE_ELECTRONICS_SUMM L"electrs"
#define IF_BASE_ENERGY_SUMM      L"energys"
#define IF_BASE_PLASMA_SUMM      L"plasmas"

#define IF_BASE_SUMM_PANEL L"res_summ"
#define IF_BASE_UNIT_PANEL L"res_unit"

#define IF_BASE_WARNING1 L"warn1"

#define IF_BASE_WEIGHT    L"weight"
#define IF_BASE_SPEED     L"speed"
#define IF_BASE_STRUCTURE L"struct"
#define IF_BASE_DAMAGE    L"damage"

#define IF_BASE_ITEM_PRICE L"itprice"

#define IF_BASE_ITEM_TEXT1  L"it_text1"
#define IF_BASE_ITEM_TEXT2  L"it_text2"
#define IF_BASE_ITEM_LABEL1 L"it_label1"
#define IF_BASE_ITEM_LABEL2 L"it_label2"

#define IF_BASE_HEAD1_ST L"head1st"
#define IF_BASE_HEAD2_ST L"head2st"
#define IF_BASE_HEAD3_ST L"head3st"
#define IF_BASE_HEAD4_ST L"head4st"

#define IF_BASE_HULL1_ST L"hull1st"
#define IF_BASE_HULL2_ST L"hull2st"
#define IF_BASE_HULL3_ST L"hull3st"
#define IF_BASE_HULL4_ST L"hull4st"
#define IF_BASE_HULL5_ST L"hull5st"
#define IF_BASE_HULL6_ST L"hull6st"

#define IF_BASE_WEAPON1_ST  L"weapon1st"
#define IF_BASE_WEAPON2_ST  L"weapon2st"
#define IF_BASE_WEAPON3_ST  L"weapon3st"
#define IF_BASE_WEAPON4_ST  L"weapon4st"
#define IF_BASE_WEAPON5_ST  L"weapon5st"
#define IF_BASE_WEAPON6_ST  L"weapon6st"
#define IF_BASE_WEAPON7_ST  L"weapon7st"
#define IF_BASE_WEAPON8_ST  L"weapon8st"
#define IF_BASE_WEAPON9_ST  L"weapon9st"
#define IF_BASE_WEAPON10_ST L"weapon10st"

#define IF_BASE_CHAS1_ST L"chas1st"
#define IF_BASE_CHAS2_ST L"chas2st"
#define IF_BASE_CHAS3_ST L"chas3st"
#define IF_BASE_CHAS4_ST L"chas4st"
#define IF_BASE_CHAS5_ST L"chas5st"

#define IF_BASE_IW_TEXT   L"iwtext"
#define IF_BASE_IW1_TEXT  L"iw1text"
#define IF_BASE_IW2_TEXT  L"iw2text"
#define IF_BASE_IW3_TEXT  L"iw3text"
#define IF_BASE_IW4_TEXT  L"iw4text"
#define IF_BASE_IW5_TEXT  L"iw5text"
#define IF_BASE_IW6_TEXT  L"iw6text"
#define IF_BASE_IW7_TEXT  L"iw7text"
#define IF_BASE_IW8_TEXT  L"iw8text"
#define IF_BASE_IW9_TEXT  L"iw9text"
#define IF_BASE_IW10_TEXT L"iw10text"

#define IF_BASE_IHU_TEXT  L"ihutext"
#define IF_BASE_IHU1_TEXT L"ihu1text"
#define IF_BASE_IHU2_TEXT L"ihu2text"
#define IF_BASE_IHU3_TEXT L"ihu3text"
#define IF_BASE_IHU4_TEXT L"ihu4text"
#define IF_BASE_IHU5_TEXT L"ihu5text"
#define IF_BASE_IHU6_TEXT L"ihu6text"

#define IF_BASE_IHE_TEXT  L"ihetext"
#define IF_BASE_IHE1_TEXT L"ihe1text"
#define IF_BASE_IHE2_TEXT L"ihe2text"
#define IF_BASE_IHE3_TEXT L"ihe3text"
#define IF_BASE_IHE4_TEXT L"ihe4text"

#define IF_BASE_ICH_TEXT  L"ichtext"
#define IF_BASE_ICH1_TEXT L"ich1text"
#define IF_BASE_ICH2_TEXT L"ich2text"
#define IF_BASE_ICH3_TEXT L"ich3text"
#define IF_BASE_ICH4_TEXT L"ich4text"
#define IF_BASE_ICH5_TEXT L"ich5text"

#define IF_BASE_WARNING       L"warn"
#define IF_BASE_WARNING1      L"warn1"
#define IF_BASE_WARNING_LABEL L"warnl"
#define IF_BASE_ZERO          L"zero"
#define IF_BASE_ONE           L"one"
#define IF_BASE_TWO           L"two"
#define IF_BASE_THREE         L"three"
#define IF_BASE_FOUR          L"four"
#define IF_BASE_FIVE          L"five"
#define IF_BASE_SIX           L"six"
#define IF_BASE_HISTORY_RIGHT L"hisright"
#define IF_BASE_HISTORY_LEFT  L"hisleft"
#define IF_BASE_COUNTHZ       L"counthz"
#define IF_BASE_UP            L"bup"
#define IF_BASE_DOWN          L"bdown"
#define IF_BASE_ITEM_CHARS    L"itch"

// Popup menu

#define IF_POPUP_TOPRIGHT      L"topright"
#define IF_POPUP_TOPLEFT       L"topleft"
#define IF_POPUP_BOTTOMRIGHT   L"bottomright"
#define IF_POPUP_BOTTOMLEFT    L"bottomleft"
#define IF_POPUP_TOPLINE       L"topline"
#define IF_POPUP_BOTTOMLINE    L"bottomline"
#define IF_POPUP_RIGHTLINE     L"rightline"
#define IF_POPUP_LEFTLINE      L"leftline"
#define IF_POPUP_SELRIGHT      L"selright"
#define IF_POPUP_SEL           L"sel"
#define IF_POPUP_SELMOUSE      L"selmouse"
#define IF_POPUP_SELRIGHTMOUSE L"selrightmouse"
#define IF_POPUP_RAMKA         L"rmka"
#define IF_POPUP_CURSIK        L"cursik"
#define IF_POPUP_SELECTOR      L"slct"
#define IF_POPUP_CURSOR        L"cursor"

// Hint fake interface

#define IF_HINTS             L"Hints"
#define IF_HINTS_OK          L"hint_ok"
#define IF_HINTS_CANCEL      L"hint_cancel"
#define IF_HINTS_CANCEL_MENU L"hint_cmenu"
#define IF_HINTS_CONTINUE    L"hint_cont"
#define IF_HINTS_SURRENDER   L"hint_surr"
#define IF_HINTS_EXIT        L"hint_exit"
#define IF_HINTS_RESET       L"hint_reset"
#define IF_HINTS_HELP        L"hint_help"

#define IF_BT1_ICON L"bt1"
#define IF_BT2_ICON L"bt2"
#define IF_BT3_ICON L"bt3"
#define IF_BT4_ICON L"bt4"

#define IF_PODL1 L"podl1"
#define IF_PODL2 L"podl2"
#define IF_PODL3 L"podl3"
#define IF_PODL4 L"podl4"

#define IF_MB_RES  L"mbres"
#define IF_TF_RES  L"tfres"
#define IF_ELF_RES L"elfres"
#define IF_ENF_RES L"enfres"
#define IF_PF_RES  L"pfres"

#define IF_BUILDING_OPIS   L"bopis"
#define IF_BASE_RES_INC    L"bresg"
#define IF_FACTORY_RES_INC L"fresg"

#define IF_MAIN_WEAPONSLOTS L"wsl"
#define IF_MAIN_SELFBOMB    L"sbo"

#define IF_MAIN_PROG   L"prog"
#define IF_BASE_RCNAME L"rcname"

#endif
